#ifndef __VXBOOT_HARDWARE_H__
# define __VXBOOT_HARDWARE_H__

#include <stdint.h>
#include <stddef.h>

/* define hardware information struct */
struct hwinfo {
	struct {
		struct {
			uintptr_t origin_addr;
			uintptr_t kernel_addr;
			uintptr_t user_addr;
		} physical;
		size_t size;
		size_t available;
	} ram;
};

//---
// hardware information API
//---

/* hardware_get_info() : get hardware information */
extern int hardware_get_info(struct hwinfo * const hwinfo);


#endif /*__VXBOOT_HARDWARE_H__*/
